program test_fphttpclient;

{$define UseCThreads}
{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes,SysUtils,ulog,ufphttpclient,uopensslsockets,openssl,unetdb
  { you can add units after this };

var
  c:TFPHTTPClient;
  r:RawByteString='';
begin
  LogText('GetDNSServers: '+GetDNSServers.ToString);
  LogText('InitSSLInterface: '+InitSSLInterface.ToString(TUseBoolStrs.True));
  LogText('IsSSLloaded: '+IsSSLloaded.ToString(TUseBoolStrs.True));

  c:=TFPHTTPClient.Create(nil);
  try
    c.AllowRedirect:=True;
    //c.ConnectTimeout:=0;//<--- Passes
    c.ConnectTimeout:=3000;//<---- Fails
    try
      r:=c.Get('https://www.google.com');
      LogText('Response Length: '+Length(r).ToString);
    except
      on e:exception do LogText(e.ClassName+': '+e.Message);
    end;
  finally
    c.Free;
  end;
end.

{
Configure Extra Tools:

adb push "$Project()" "/data/local/tmp"
adb shell chmod 755 /data/local/tmp/$ProjFile()
adb shell /data/local/tmp/$ProjFile()

OR

adb push "$Project()" "/data/local/tmp" && adb shell chmod 755 /data/local/tmp/$ProjFile() && adb shell /data/local/tmp/$ProjFile()
}
